preinst is in postfix 2.9.1-4.
This file is a maintainer script. It is executed when installing (*inst) or removing (*rm) the package.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 | #!/bin/sh -e
# Debian Postfix preinst
# LaMont Jones <lamont@debian.org>
# Modified to use debconf by Colin Walters <levanti@verbum.org>
# do we have debconf?
if [ -f /usr/share/debconf/confmodule ]; then
. /usr/share/debconf/confmodule
DEBCONF=true
else
DEBCONF=
fi
dpkg_vers=$(dpkg --status dpkg | sed -n '/Version: /s/^Version: //p')
CONFIG=/etc/postfix/main.cf
MASTER=/etc/postfix/master.cf
POSTDROP=/usr/sbin/postdrop
mydomain_warning() {
if [ -n "$DEBCONF" ]; then
db_fset postfix/mydomain_warning seen false
db_input medium postfix/mydomain_warning || true
db_go || true
db_get postfix/mydomain_warning
if [ "$RET" = "false" ]; then
echo "aborting postfix install"
exit 1
fi
else
# no debconf, fall back
cat << EOF
Postfix version 2.3.3-2 and later require changes in main.cf.
Specifically, mydomain must be specified, since hostname(2) is not
an FQDN.
EOF
echo -n "Shall I make the change? "
read line
case ${line} in
[nN]*) echo "aborting postfix install"
exit 1
;;
esac
fi
}
retry_warning() {
if [ -n "$DEBCONF" ]; then
db_fset postfix/retry_upgrade_warning seen false
db_input medium postfix/retry_upgrade_warning || true
db_go || true
db_get postfix/retry_upgrade_warning
if [ "$RET" = "false" ]; then
echo "aborting postfix install"
exit 1
fi
else
# no debconf, fall back
cat << EOF
Postfix version 2.4 requires that the retry service be added to master.cf
EOF
echo -n "Shall I make the change? "
read line
case ${line} in
[nN]*) echo "aborting postfix install"
exit 1
;;
esac
fi
}
tlsmgr_warning() {
if [ -n "$DEBCONF" ]; then
db_fset postfix/tlsmgr_upgrade_warning seen false
db_input medium postfix/tlsmgr_upgrade_warning || true
db_go || true
db_get postfix/tlsmgr_upgrade_warning
if [ "$RET" = "false" ]; then
echo "aborting postfix install"
exit 1
fi
else
# no debconf, fall back
cat << EOF
Postfix version 2.2 has changed the invocation of tlsmgr.
EOF
echo -n "Shall I make the change? "
read line
case ${line} in
[nN]*) echo "aborting postfix install"
exit 1
;;
esac
fi
}
kernel_version_warning() {
if [ -n "$DEBCONF" ]; then
db_fset postfix/kernel_version_warning seen false
db_input low postfix/kernel_version_warning || true
db_go || true
db_get postfix/kernel_version_warning
else
cat << EOF
Postfix uses features that are not found in kernels prior to 2.6. If you
proceeed with the installation, Postfix will not run.
EOF
RET=false
fi
if [ "$RET" = "false" ]; then
echo "Aborting postfix install"
exit 1
fi
}
(umask 022; mkdir -p /var/spool/postfix)
case "$1" in
install)
rm -f /var/spool/postfix/restart /var/spool/postfix/reload
# workaround sendmail not unregistering itself...
if [ -e /etc/suid.conf ] && [ -x /usr/sbin/suidunregister ]; then
if grep -q sendmail /etc/suid.conf; then
/usr/sbin/suidunregister -s postfix /usr/sbin/sendmail
fi
fi
if [ -L /etc/postfix/postfix-script ]; then
rm -f /etc/postfix/postfix-script
fi
;;
upgrade)
version=$2
if [ -d /var/spool/postfix ] && [ -f /etc/postfix/main.cf ]; then
touch /var/spool/postfix/restart
fi
export LANG=C # for the comparison of mail version...
if dpkg --compare-versions "`uname -r`" lt 2.6.0 ; then
kernel_version_warning
fi
if [ -L /etc/postfix/postfix-script ]; then
rm -f /etc/postfix/postfix-script
fi
if grep -q '^tlsmgr[[:space:]]*fifo' $MASTER; then
tlsmgr_warning
fi
if dpkg --compare-versions $version lt 2.3.5-1; then
# droping 10hostname.dpatch forces cleanup.
if [ -z "$(postconf -n mydomain 2>/dev/null || true)" ]; then
myhost=$(hostname 2>/dev/null)
if [ "X${myhost%.*}" = "X${myhost}" ]; then
mydomain_warning
touch /var/spool/postfix/mydomain-upgrade
fi
fi
fi
if ! grep -q '^retry[[:space:]]' $MASTER; then
retry_warning
fi
invoke-rc.d --quiet postfix stop || true
;;
abort-upgrade)
;;
*)
echo "preinst called with unknown argument \`$1'" >&2
exit 1
;;
esac
if [ install = "$1" -o upgrade = "$1" ]; then
# cleanup after past mistakes.
rm -f /usr/sbin/postconf.postfix
dpkg-divert --package postfix-tls --remove \
--divert /usr/sbin/postconf.postfix \
/usr/sbin/postconf >/dev/null 2>/dev/null
fi
|